import type { DbClientContract, EnhancementContext } from '../../types';
import type { InternalEnhancementOptions } from './create-enhancement';
import { DefaultPrismaProxyHandler } from './proxy';
export declare function withDelegate<DbClient extends object>(prisma: DbClient, options: InternalEnhancementOptions, context: EnhancementContext | undefined): DbClient;
export declare class DelegateProxyHandler extends DefaultPrismaProxyHandler {
    private readonly context;
    private readonly logger;
    private readonly queryUtils;
    constructor(prisma: DbClientContract, model: string, options: InternalEnhancementOptions, context: EnhancementContext | undefined);
    findFirst(args: any): Promise<unknown>;
    findFirstOrThrow(args: any): Promise<unknown>;
    findUnique(args: any): Promise<unknown>;
    findUniqueOrThrow(args: any): Promise<unknown>;
    findMany(args: any): Promise<unknown[]>;
    private doFind;
    private ensureDiscriminatorSelection;
    private injectWhereHierarchy;
    private injectSelectIncludeHierarchy;
    private buildSelectIncludeHierarchy;
    private injectBaseFieldSelect;
    private injectBaseIncludeRecursively;
    private injectConcreteIncludeRecursively;
    private createConcreteRelationIncludePayload;
    create(args: any): Promise<any>;
    private sanitizeMutationPayload;
    createMany(args: {
        data: any;
        skipDuplicates?: boolean;
    }): Promise<{
        count: number;
    }>;
    createManyAndReturn(args: {
        data: any;
        select?: any;
        skipDuplicates?: boolean;
    }): Promise<unknown[]>;
    private doCreate;
    private injectCreateHierarchy;
    private doProcessCreatePayload;
    private ensureBaseCreateHierarchy;
    private fkAssignmentToConnect;
    private injectBaseFieldData;
    update(args: any): Promise<unknown>;
    updateMany(args: any): Promise<{
        count: number;
    }>;
    upsert(args: any): Promise<unknown>;
    private doUpdate;
    private doUpdateMany;
    private injectUpdateHierarchy;
    private doProcessUpdatePayload;
    delete(args: any): Promise<unknown>;
    deleteMany(args: any): Promise<{
        count: number;
    }>;
    private doDeleteMany;
    private deleteBaseRecursively;
    private doDelete;
    private getRelationDelegateEntitiesForCascadeDelete;
    private isFieldCascadeDelete;
    aggregate(args: any): Promise<unknown>;
    count(args: any): Promise<unknown>;
    groupBy(args: any): Promise<unknown>;
    private checkAggregationArgs;
    private extractSelectInclude;
    private makeAuxRelationName;
    private getModelName;
    private getIdFields;
    private getModelInfo;
    private getBaseModel;
    private involvesDelegateModel;
    private isDelegateOrDescendantOfDelegate;
    private assembleHierarchy;
    private assembleUp;
    private assembleDown;
    private getUpdatedAtFromDelegateBases;
}
