/**
 * A logger that uses an existing Prisma client to emit.
 */
export declare class Logger {
    private readonly prisma;
    private emitter;
    private eventNames;
    constructor(prisma: any);
    /**
     * Checks if a log level is enabled.
     */
    enabled(level: 'info' | 'warn' | 'error'): boolean;
    /**
     * Generates a message with the given level.
     */
    log(level: 'info' | 'warn' | 'error', message: string): void;
    /**
     * Generates a log message with info level.
     */
    info(message: string): void;
    /**
     * Generates a log message with warn level.
     */
    warn(message: string): void;
    /**
     * Generates a log message with error level.
     */
    error(message: string): void;
}
