import type { PermissionCheckerConstraint } from '../types';
/**
 * A boolean constraint solver based on `logic-solver`. Only boolean and integer types are supported.
 */
export declare class ConstraintSolver {
    private stringTable;
    private variables;
    /**
     * Check the satisfiability of the given constraint.
     */
    checkSat(constraint: PermissionCheckerConstraint): boolean;
    private buildFormula;
    private buildLogicalFormula;
    private buildAndFormula;
    private buildOrFormula;
    private buildNotFormula;
    private isTrue;
    private isFalse;
    private buildComparisonFormula;
    private buildVariableFormula;
    private buildValueFormula;
    private booleanVariable;
    private intVariable;
    private transformEquality;
    private transformInequality;
    private transformComparison;
}
