import { DbClientContract, EnhancementContext } from '../../../types';
import type { InternalEnhancementOptions } from '../create-enhancement';
/**
 * Gets an enhanced Prisma client with access policy check.
 *
 * @param prisma The original Prisma client
 * @param context The policy evaluation context
 * @param policy The policy definition, will be loaded from default location if not provided
 * @param modelMeta The model metadata, will be loaded from default location if not provided
 *
 * @private
 */
export declare function withPolicy<DbClient extends object>(prisma: DbClient, options: InternalEnhancementOptions, context?: EnhancementContext): DbClient;
/**
 * Function for processing a payload for including a relation field in a query.
 * @param model The relation's model name
 * @param payload The payload to process
 */
export declare function policyProcessIncludeRelationPayload(prisma: DbClientContract, model: string, payload: unknown, options: InternalEnhancementOptions, context: EnhancementContext | undefined): Promise<void>;
