import { type ModelMeta } from '../../cross';
/**
 * Creates a promise that only executes when it's awaited or .then() is called.
 * @see https://github.com/prisma/prisma/blob/main/packages/client/src/runtime/core/request/createPrismaPromise.ts
 */
export declare function createDeferredPromise<T>(callback: () => Promise<T>): Promise<T>;
/**
 * Create a deferred promise with fluent API call stub installed.
 *
 * @param callback The callback to execute when the promise is awaited.
 * @param parentArgs The parent promise's query args.
 * @param modelMeta The model metadata.
 * @param model The model name.
 */
export declare function createFluentPromise(callback: () => Promise<any>, parentArgs: any, modelMeta: ModelMeta, model: string): Promise<any>;
