"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPrismaClientKnownRequestError = isPrismaClientKnownRequestError;
exports.isPrismaClientUnknownRequestError = isPrismaClientUnknownRequestError;
exports.isPrismaClientValidationError = isPrismaClientValidationError;
/* eslint-disable @typescript-eslint/no-explicit-any */
function isPrismaClientKnownRequestError(err) {
    return findConstructorName(err.__proto__, 'PrismaClientKnownRequestError');
}
function isPrismaClientUnknownRequestError(err) {
    return findConstructorName(err.__proto__, 'PrismaClientUnknownRequestError');
}
function isPrismaClientValidationError(err) {
    return findConstructorName(err.__proto__, 'PrismaClientValidationError');
}
function findConstructorName(proto, name) {
    if (!proto) {
        return false;
    }
    return proto.constructor.name === name || findConstructorName(proto.__proto__, name);
}
//# sourceMappingURL=error.js.map